
#include <stdlib.h>
#include <stddef.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <stdio.h>
#include <sys/wait.h>
#include <gtk/gtk.h>
#include "support.h"
#include "imgcp.h"
#include "interface.h"

gint gdrdao_imgcp_getdata(GtkWidget* _widget,
		struct gdrdao_imgcp_data* _use) {
	GtkWidget *tmp;
	char *q;
	
	tmp=lookup_widget(_widget,"imgcp_src_devsg");
	_use->src_devsg=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(tmp));
	tmp=lookup_widget(_widget,"imgcp_dest_devsg");
	_use->dest_devsg=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(tmp));
	tmp=lookup_widget(_widget,"imgcp_src_image");
	q=gnome_file_entry_get_full_path(GNOME_FILE_ENTRY(tmp), FALSE);
	strcpy(_use->src_imgfile,q);
	return 0;
};


gint gdrdao_imgcp_readcd(struct gdrdao_imgcp_data* _use) {
	/* simply execute the cdrdao command line */
	char tmp[8192];
	char **argv;
	gint args;
	register long i;
	pid_t pid;
	int status;
	GtkWidget* widget;
	
	args=0;
	argv=(char**)malloc(sizeof(char*)*64); /* 64 args should be enough */

	argv[args]=(char*)malloc(strlen("cdrdao")+1);
	strcpy(argv[args++],"cdrdao"); /* program name is always argv[0] */
	argv[args]=(char*)malloc(strlen("read-cd")+1);
	strcpy(argv[args++],"read-cd"); /* what do we wanna do? */
	
	argv[args]=(char*)malloc(strlen("--device")+1);
	strcpy(argv[args++],"--device");
	sprintf(tmp,"/dev/sg%i",_use->src_devsg);
	argv[args]=(char*)malloc(strlen(tmp)+1);
	strcpy(argv[args++],tmp); /* specify read device */
	
	argv[args]=(char*)malloc(strlen("--datafile")+1);
	strcpy(argv[args++],"--datafile");
	argv[args]=(char*)malloc(strlen(_use->src_imgfile)+1);
	strcpy(argv[args++],_use->src_imgfile);
	
	sprintf(tmp,"%s.toc",_use->src_imgfile);
	argv[args]=(char*)malloc(strlen(tmp)+1);
	strcpy(argv[args++],tmp); /* specify toc file */

	argv[args]=NULL; /* finish me! */
	
	/* ok, we now have all command line parameters */
	/*q=execvp("cdrdao",argv);
	printf("%i\n",q);
	*/
	pid=fork();
	if(pid==0) {
		/* child is here */
		execvp("cdrdao",argv);
		_exit(EXIT_FAILURE);
	} else if(pid<0) {
		widget=create_msg_err_fork();
		gtk_widget_show(widget);
		return 1;
	} else if(waitpid(pid,&status,0)!=pid) {
	};
	for(i=0;i<args;++i) free(argv[args]); free(argv);
	return 0;
};


gint gdrdao_imgcp_writecd(struct gdrdao_imgcp_data* _use) {
        /* simply execute the cdrdao command line */
        char tmp[8192];
        char **argv;
        gint args;
        register long i;
        pid_t pid;
        int status;
        GtkWidget* widget;

        args=0;
        argv=(char**)malloc(sizeof(char*)*64); /* 64 args should be enough */

        argv[args]=(char*)malloc(strlen("cdrdao")+1);
        strcpy(argv[args++],"cdrdao"); /* program name is always argv[0] */
	argv[args]=(char*)malloc(strlen("write")+1);
	strcpy(argv[args++],"write"); /* basic command... */

	argv[args]=(char*)malloc(strlen("--datafile")+1);
	strcpy(argv[args++],"--datafile"); /* which image to use */
	argv[args]=(char*)malloc(strlen(_use->src_imgfile)+1);
	strcpy(argv[args++],_use->src_imgfile);

	sprintf(tmp,"%s.toc",_use->src_imgfile);
	argv[args]=(char*)malloc(strlen(tmp)+1);
	strcpy(argv[args++],tmp);
	
	argv[args]=NULL; /* what would I do without you? */

	/* all arguments above that line! */
        pid=fork();
        if(pid==0) {
                /* child is here */
                execvp("cdrdao",argv);
                _exit(EXIT_FAILURE);
        } else if(pid<0) {
                widget=create_msg_err_fork();
                gtk_widget_show(widget);
                return 1;
        } else if(waitpid(pid,&status,0)!=pid) {
        };
        for(i=0;i<args;++i) free(argv[args]); free(argv);
        return 0;
};

	
